#!/usr/local/bin/perl
package split_image;
use warnings;
use Image::Magick;
use File::Basename;
our $frame_width  = 320;
our $frame_height = 320;
# main
sub split_imagedata {
foreach ( @ARGV ){
	my $filename = $_;
	if ( -e $filename ) {
		cut_img( $filename );
	}
  }
}
sub cut_img {
my $filename = shift;
our ( $frame_width, $frame_height );
my $img_orig = Image::Magick->new;
$img_orig->Read( $filename );
my ($width, $height) = $img_orig->Get('width', 'height');
my $frame = $width / $frame_width;
my $frame2 = $height / $frame_height;

$temp = int($frame2);

if ( $frame > 1 ) {
for ( my $i = 0;$i < $frame;$i++ ) {
	for ( my $j = 0;$j < $frame2;$j++ ) {
		my $img = $img_orig->Clone();
		$img->Roll(
		x=>(-1)*$i*($width/$frame),
		y=>(-1)*$j*($height/$frame2),);
		if($j==$temp){
			$img->Chop(
			width  => $width,
			height => $height-($height-$frame_height*$temp),
			x => $frame_width,
			y => $height-$frame_height*$temp,);
		}else{
		$img->Chop(
		width  => $width,
		height => $height-$frame_height,
		x => $frame_width,
		y => $frame_height,);
		}
		$img->write( make_filename( $filename, ($i+1)*10+$j ) );
		undef $img;
		}
	}
}
undef $img_orig;
return;
}  
sub make_filename {
  my $path = shift;
  my $num  = shift;
  my($filename, $directories, $suffix)    = fileparse($path, qr/\.[^.]*/ );
  return "$directories${filename}_$num$suffix";
}
1;